//
//  TwitterDemoViewController.m
//  TwitterDemo
//
//  Created by Michal Čerňanský on 24.11.2010.
//  Copyright 2010 FIIT STU Bratislava. All rights reserved.
//

#import "TwitterDemoViewController.h"
#import "DetailView.h"


@implementation TwitterDemoViewController
@synthesize twitterApiParser, tweetTable;


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	self.twitterApiParser = [[TwitterApi alloc] initWithService:@"public_feed" delegate:self];
}

- (void)apiCallFinished:(TwitterApi*) twitterApi withData:(NSMutableArray*)data {
	NSLog(@"%@", data);
	[tweetTable reloadData];
}

- (void)viewWillAppear:(BOOL)animated {
	NSLog(@"WillAppear");
	[self.tweetTable deselectRowAtIndexPath:[self.tweetTable indexPathForSelectedRow] animated:YES];
}
- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
    [super dealloc];
}


- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
		NSMutableDictionary *internalData = [twitterApiParser.model objectAtIndex:indexPath.row];
		UITableViewCell *cell = [tweetTable dequeueReusableCellWithIdentifier:@"CellIdentifier"];
	if (!cell) {
		cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle
									  reuseIdentifier:@"CellIdentifier"];
		cell.detailTextLabel.numberOfLines = 0;	
		[cell.textLabel setFont:[UIFont boldSystemFontOfSize:14.0f]];
		[cell.detailTextLabel setTextColor:[UIColor blackColor]];
	}

	[cell.textLabel setText: [internalData objectForKey:@"screen_name"]];
	[cell.detailTextLabel setText: [internalData objectForKey:@"text"]];
	
	return cell;
}

- (int)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [self.twitterApiParser.model count];
}


- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
	NSMutableDictionary *internalData = [twitterApiParser.model objectAtIndex:indexPath.row];
	NSString *tmpText = (NSString*)[internalData objectForKey:@"text"];
	CGSize szCell = [tmpText sizeWithFont:[UIFont systemFontOfSize:14.0f] 
						constrainedToSize:CGSizeMake(265.0f, CGFLOAT_MAX) 
							lineBreakMode:UILineBreakModeWordWrap];

	return szCell.height + 30;
	
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	DetailView *detailView = [[DetailView alloc] initWithNibName:@"DetailView" bundle:[NSBundle mainBundle]];
	[detailView setModel:[twitterApiParser.model objectAtIndex:indexPath.row]];
	[self.navigationController pushViewController:detailView animated:YES];
	[detailView release];
}


@end
